/**********
 Coded by Thanassis Tsiodras

 in about ... 20 minutes
***********/

#include <stdio.h>

unsigned char indata[16384];
short outdata[16384];

error(char *s)
{
  puts(s);
  exit(0);
}

swap(unsigned int *i)
{
  register unsigned int s;
  register unsigned int u;

  s=(*i & 0xFF000000)>>24;
  u=s;
  s=(*i & 0xFF0000)>>8;
  u|=s;
  s=(*i & 0xFF00)<<8;
  u|=s;
  s=(*i & 0xFF)<<24;
  u|=s;
  *i=u;
}

main(int argc,char *argv[])
{
  FILE *fpin,*fpout;
  char id[5]="1234";
  unsigned int start,size,encoding,rate, channels;
  int numread,i,totalwritten=0;
  char fname[128];

  if (argc!=2)
    error("Syntax: au2raw filename.au");
  strcpy(fname,argv[1]);
  if (!strchr(fname,'.'))
    strcat(fname,".au");
  if((fpin=fopen(fname,"rb"))==NULL)
    error("Can't find file.");
  if((fpout=fopen("output.raw","wb"))==NULL)
    error("Can't open output file.");

  fread(id,1,4,fpin);
  if(strcmp(id,".snd"))
    error("Not a SUN audio file.");
  fread(&start,1,4,fpin);       swap(&start);
  fread(&size,1,4,fpin);        swap(&size);
  fread(&encoding,1,4,fpin);    swap(&encoding);
  fread(&rate, 1,4,fpin);       swap(&rate);
  fread(&channels,1,4,fpin);    swap(&channels);
  printf("Start of data : %d\n",start);
  printf("Size of data  : %d\n",size);
  printf("Encoding      : %s\n",(encoding==1)?"8-bit U-Law":"16-bit PCM");
  printf("Sampling rate : %d\n",rate);
  printf("Channels      : %d\n",channels);
  fseek(fpin, start, SEEK_SET);
  puts("\nWriting output to:   output.raw\nBytes written:           ");
  while(!feof(fpin)) {
    numread=fread(indata,1,16384,fpin);
    for(i=0;i<numread;i++)
      outdata[i]=ulaw2linear(indata[i]);
    fwrite(outdata,2,numread,fpout);
    totalwritten+=(numread*2);
    printf("\b\b\b\b\b\b\b\b%8d",totalwritten);
  }
  fclose(fpin);
  fclose(fpout);
}
