#include "frame.h"
#include "vector.h"
#include "povproto.h"
#include "parse.h"

#include "povwrite.h"

/********************/
// parse.c Hilfsfunktionen

int my_print_active = 0;
static FILE *my_fptr = NULL;

int my_print_init(char *file_name)
{
	my_fptr = fopen(file_name, "w");
	if(my_fptr == NULL)
	{
		fprintf(stderr, "\nCannot open file %s\n", file_name);
		return 1;
	}
//	fprintf(stderr, "\nWriting Clear POV File ...\n");
//	my_fptr = stdout;
	return 0;
}
void my_print_exit(void)
{
	if(my_fptr != NULL)
		fclose(my_fptr);
	fprintf(stderr, "Finished\n");
}


void my_print_string(char *t)
{
	if(!my_print_active)
		return;
	if(t == NULL)
		return;
	fprintf(my_fptr, "%s\n",t);
}

void my_print_real_string(char *t)
{
	if(!my_print_active)
		return;
	if(t == NULL)
		return;
	fprintf(my_fptr, "\"%s\"\n",t);
}

void my_print_string_pure(char *t)
{
	if(!my_print_active)
		return;
	if(t == NULL)
		return;
	fprintf(my_fptr, "%s",t);
}

void my_print_color(COLOUR *t)
{
	if(!my_print_active)
		return;
	fprintf(my_fptr, "rgbf <%f, %f, %f, %f>\n", t->Red, t->Green, t->Blue, t->Filter);
}

void my_print_color_map(COLOUR_MAP *t)
{
	int i;
	if(!my_print_active)
		return;
	for(i = 0; i < t->Number_Of_Entries;i++)
	{

		fprintf(my_fptr, "[%f color rgbf <%f, %f, %f, %f>]\n",
		t->Colour_Map_Entries[i].value,
		t->Colour_Map_Entries[i].Colour.Red,
		t->Colour_Map_Entries[i].Colour.Green,
		t->Colour_Map_Entries[i].Colour.Blue,
		t->Colour_Map_Entries[i].Colour.Filter);

	}

/*
struct Colour_Map_Entry
  {
   DBL value;
   COLOUR Colour;
  };

struct Colour_Map_Struct
  {
   int Number_Of_Entries, Transparency_Flag, Users;
   COLOUR_MAP_ENTRY *Colour_Map_Entries;
  };
*/
}


void my_print_vector(VECTOR *t)
{
	if(!my_print_active)
		return;
	fprintf(my_fptr, "<%f, %f, %f>\n", t->x, t->y, t->z);
}

void my_print_float(float t)
{
	if(!my_print_active)
		return;
	fprintf(my_fptr, "%f\n", t);
}

void my_print_int(int t)
{
	if(!my_print_active)
		return;
	fprintf(my_fptr, "%d\n", t);
}


void my_print_komma(void)
{
	if(!my_print_active)
		return;
	fprintf(my_fptr, ",\n");
}

void my_print_begin(void)
{
	if(!my_print_active)
		return;
	fprintf(my_fptr, "{\n");
}

void my_print_end(void)
{
	if(!my_print_active)
		return;
	fprintf(my_fptr, "}\n");
}



